﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Routing;
using System.Web.Mvc;

namespace Web.UI3
{
    public class CustomMVCHandler : IHttpHandler 
    {
        #region IHttpHandler Members
        public bool IsReusable { get { return true; } }
        public void ProcessRequest(HttpContext context)
        {
            string controllerId = RequestContext.RouteData.GetRequiredString("controller");
            IController controller = null;
            IControllerFactory factory = null;
            try
            {
                factory = ControllerBuilder.Current.GetControllerFactory();
                controller = factory.CreateController(RequestContext, controllerId);
                if (controller != null)
                {
                    controller.Execute(RequestContext);
                }
                context.Response.Write("<strong><FONT COLOR=\"red\">CustomMVCHandler was called.</FONT></strong>");
            }
            finally
            {
                factory.ReleaseController(controller);
            } 
        }
        #endregion

        public RequestContext RequestContext { get; set; }

        public CustomMVCHandler(RequestContext requestContext)
        {
            this.RequestContext = requestContext;
        } 
    }
}